#!/usr/bin/perl
#                   - CGI Library v1.2 -                      #
# This script created on Jun 1999 by Web Programming Services #
# http://www.fido7.com/services/              yuryk@fido7.com #
#                                                             #
###############################################################


sub ReadParse {
  local (*in) = @_ if @_;

  local ($i, $loc, $key, $val);

  if ($ENV{'REQUEST_METHOD'} eq "GET") { $in = $ENV{'QUERY_STRING'} }
  elsif ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN,$in,$ENV{'CONTENT_LENGTH'}) }

  @in = split(/&/,$in);

  foreach $i (0 .. $#in) {
    $in[$i] =~ s/\+/ /g;
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $in{$key} .= "," if (defined($in{$key}));
    $in{$key} .= $val;
  }
}


sub printheader {
  print "Content-type: text/html\n\n";
}

sub redirpage {
  print "Location: ".$_[0]."\n\n";
}

sub inweb {
  local($iwstr)=shift;
  $iwstr=~s/\cM//g;
  $iwstr=~s/ /+/g;
  $iwstr=~s/\n/%0D%0A/g;
  $iwstr=~s/</%3C/g;
  $iwstr=~s/>/%3E/g;
  $iwstr=~s/"/%22/g;
  $iwstr=~s/\//%2F/g;
  $iwstr=~s/&/%26/g;
  return $iwstr;
}             

sub sendmail
{
  ($sm_to,$sm_subj,$sm_text)=@_;

  $sendmail="/usr/lib/sendmail";
  open(MAIL,"|$sendmail $sm_to") || die ("Couldnt start mail program ($!)");

  print(MAIL "To: $sm_to\n");
  print(MAIL "Subject: $sm_subj\n");
  print(MAIL "From: $email_from\n");
  print(MAIL "\n");
  print(MAIL "$sm_text");
  print(MAIL ".\n");
  close(MAIL);
}

sub timenc {
   local($etime)=shift;
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($etime);
   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);
   $fyear=$year+1900;
   $year=substr($fyear,2,2);

   @months = ("January","February","March","April","May","June","July","August","September","October","November","December");
   
   $date = "$hour\:$min\:$sec $month/$mday/$year";
   
   chop($date) if ($date =~ /\n$/);
   $long_date = "$months[$mon] $mday, $fyear at $hour\:$min\:$sec";
   return $date;
}

sub showerror {
  local ($message)=shift;
  print "Content-type: text/html\n\n";
  print <<"end_print";
<html>
<head>
<title>Error</title>
</head>
<body bgcolor="#FFFFFF" text="#000000" >
Error: $message<hr>
<form><input type=button value=\"Back\" onclick=\"history.go(-1)\"></form>
</body></html>
end_print
exit;
}

sub wwwgrab {

($_, $savefilename) = @_;

/http:\/\/([^\/]*)\/*([^ ]*)/;
$site = $1;
$file = "/".$2;
@wwwgrab=();

if (!$site) {
  return;
  die "$0:  Fatal Error.  You appear to have munged your URL address.\nIt must be in the form of http://www.any.site/location\n";
}

$_ = $site;
/^([^:]*):*([^ ]*)/;
$site = $1;
$port = $2;
$port = 80 unless $port;

$hostname = $site;

#print STDERR "[$site] [$port] [$file]\n";

# Open a socket and get the data
  ($sockaddr,$there,$response,$tries) = ("Snc4x8");
  $there = pack($sockaddr,2,$port, &getaddress($hostname));
  ($a, $b, $c, $d) = unpack('C4', $hostaddr);

  $proto = (getprotobyname ('tcp'))[2];

  #if (!socket(S,AF_INET,SOCK_STREAM,$proto)) { die "$0:  Fatal Error.  $!\n"; }
  if (!socket(S,2,1,6)) { return; die "$0:  Fatal Error.  $!\n"; }
  if (!connect(S,$there)) { return; die "$0:  Fatal Error.  $!\n"; }
  select(S);$|=1;
  select(STDOUT);
  print S "GET $file\r\n";
  if ($savefilename) {
    open(OUT,">".$savefilename) || die "$0: Fatal error.  Cannot create $savefilename.\n";
  } else { @wwwgrab=() }
  while($line = <S>) {
    if ($savefilename) {
      print OUT $line;
    } else {
      push (@wwwgrab, $line);
    }
  }
  close(S);
  if ($savefilename) {
    close(OUT);
  }
}

sub getaddress {
  local($host) = @_;
  local(@ary);
  @ary = gethostbyname($host);
  return(unpack("C4",$ary[4]));
}



1;